///////////////////////////////////////////////////////////////////////////////////////////
//
// RECORDER.HPP - Declaration of AKeystrokeRecorderApp, the Keystroke Recorder Application
//
// (c) 1998 by Stefan Ruck, Frankfurt/Main, Germany
//
///////////////////////////////////////////////////////////////////////////////////////////
#ifndef _RECORDER_HPP_
#define _RECORDER_HPP_

#ifndef _IFRAME_
#include <iframe.hpp>
#endif

#ifndef _ICMDHDR_
#include <icmdhdr.hpp>
#endif

#ifndef _IMLE_
#include <imle.hpp>
#endif

#ifndef _IMENUBAR_
#include <imenubar.hpp>
#endif

#ifndef _IKEYHDR_
#include <ikeyhdr.hpp>
#endif

#ifndef _ISTATTXT_
#include <istattxt.hpp>
#endif

#ifndef _ISEQ_
#include <iseq.h>
#endif

class AKeystrokeRecorderApp : public IFrameWindow,
                              public ICommandHandler,
                              public IKeyboardHandler

{
  public:                               
    AKeystrokeRecorderApp (unsigned long ulWindowID); // Constructor
    virtual ~AKeystrokeRecorderApp ();                // Destructor for this class

  protected:
    virtual Boolean command(ICommandEvent & evt);              // command handling

    virtual Boolean virtualKeyPress (IKeyboardEvent &event)   // handling virtual key presses
                                { return (handleKeyPress (event)); }
    virtual Boolean characterKeyPress (IKeyboardEvent &event)  // handling character key presses
                                { return (handleKeyPress (event)); }

  private:
    void setupClientArea ();                          // set up the client area

    void recorderStartStop ();                        // starts / stops the recorder
    void recorderPauseResume ();                      // pauses / resumes the recorder
    void recorderPlay ();                             // plays the recorded key strokes

    Boolean handleKeyPress (IKeyboardEvent & event);  // standard key press handling

    IMultiLineEdit * m_pEditField;                    // EditField for keystroke-recording
    IMenuBar * m_pMenuBar;                            // MenuBar of the frame window
    ISequence<IKeyboardEvent> * m_pKeyRecorderList;   // the list of keystroke events
    IStaticText * m_pStatusLine;                      // the status line of the frame

    Boolean m_bRecordKeystrokes;                      // shall we record?
    Boolean m_bRecordingPaused;                       // is pause active? 
};


#endif //_RECORDER_HPP_
